diff --git a/langtools/src/share/classes/com/sun/tools/apt/mirror/declaration/AnnotationValueImpl.java b/langtools/src/share/classes/com/sun/tools/apt/mirror/declaration/AnnotationValueImpl.java
index b99bb8a..321a53e 100644
--- a/langtools/src/share/classes/com/sun/tools/apt/mirror/declaration/AnnotationValueImpl.java
+++ b/langtools/src/share/classes/com/sun/tools/apt/mirror/declaration/AnnotationValueImpl.java
@@ -57,6 +57,7 @@ public class AnnotationValueImpl implements AnnotationValue {
     /**
      * {@inheritDoc}
      */
+    @Override
     public String toString() {
         StringBuilder sb = new StringBuilder();
         Constants.Formatter fmtr = Constants.getFormatter(sb);
@@ -114,6 +115,10 @@ public class AnnotationValueImpl implements AnnotationValue {
             value = vals;
         }
 
+        public void visitExpression(Attribute.Expression e) {
+            value = e;
+        }
+        
         public void visitError(Attribute.Error e) {
             value = "<error>";  // javac will already have logged an error msg
         }
diff --git a/langtools/src/share/classes/com/sun/tools/javac/code/Attribute.java b/langtools/src/share/classes/com/sun/tools/javac/code/Attribute.java
index 09b2670..38f50b6 100644
--- a/langtools/src/share/classes/com/sun/tools/javac/code/Attribute.java
+++ b/langtools/src/share/classes/com/sun/tools/javac/code/Attribute.java
@@ -25,16 +25,19 @@
 
 package com.sun.tools.javac.code;
 
-import java.util.LinkedHashMap;
-import java.util.Map;
-import javax.lang.model.element.AnnotationMirror;
-import javax.lang.model.element.AnnotationValue;
-import javax.lang.model.element.AnnotationValueVisitor;
-import javax.lang.model.type.DeclaredType;
+import static com.sun.tools.javac.code.TypeTags.*;
+
+import com.sun.source.tree.ExpressionTree;
 import com.sun.tools.javac.code.Symbol.*;
+import com.sun.tools.javac.tree.JCTree.JCExpression;
 import com.sun.tools.javac.util.*;
+import com.sun.tools.javac.util.List;
+import com.sun.tools.javac.util.Name;
 
-import static com.sun.tools.javac.code.TypeTags.*;
+import java.util.*;
+
+import javax.lang.model.element.*;
+import javax.lang.model.type.DeclaredType;
 
 /** An annotation value.
  *
@@ -66,17 +69,21 @@ public abstract class Attribute implements AnnotationValue {
     /** The value for an annotation element of primitive type or String. */
     public static class Constant extends Attribute {
         public final Object value;
+        @Override
         public void accept(Visitor v) { v.visitConstant(this); }
         public Constant(Type type, Object value) {
             super(type);
             this.value = value;
         }
+        @Override
         public String toString() {
             return Constants.format(value, type);
         }
+        @Override
         public Object getValue() {
             return Constants.decode(value, type);
         }
+        @Override
         public <R, P> R accept(AnnotationValueVisitor<R, P> v, P p) {
             if (value instanceof String)
                 return v.visitString((String) value, p);
@@ -104,6 +111,7 @@ public abstract class Attribute implements AnnotationValue {
      */
     public static class Class extends Attribute {
         public final Type type;
+        @Override
         public void accept(Visitor v) { v.visitClass(this); }
         public Class(Types types, Type type) {
             super(makeClassType(types, type));
@@ -117,12 +125,15 @@ public abstract class Attribute implements AnnotationValue {
                                       List.of(arg),
                                       types.syms.classType.tsym);
         }
+        @Override
         public String toString() {
             return type + ".class";
         }
+        @Override
         public Type getValue() {
             return type;
         }
+        @Override
         public <R, P> R accept(AnnotationValueVisitor<R, P> v, P p) {
             return v.visitType(type, p);
         }
@@ -143,6 +154,7 @@ public abstract class Attribute implements AnnotationValue {
             super(type);
             this.values = values;
         }
+        @Override
         public void accept(Visitor v) { v.visitCompound(this); }
 
         /**
@@ -153,6 +165,7 @@ public abstract class Attribute implements AnnotationValue {
          *     @com.example.foo
          * Omit parens for marker annotations, and omit "value=" when allowed.
          */
+        @Override
         public String toString() {
             StringBuilder buf = new StringBuilder();
             buf.append("@");
@@ -183,10 +196,12 @@ public abstract class Attribute implements AnnotationValue {
             return null;
         }
 
+        @Override
         public Attribute.Compound getValue() {
             return this;
         }
 
+        @Override
         public <R, P> R accept(AnnotationValueVisitor<R, P> v, P p) {
             return v.visitAnnotation(this, p);
         }
@@ -227,7 +242,9 @@ public abstract class Attribute implements AnnotationValue {
             super(type);
             this.values = values;
         }
+        @Override
         public void accept(Visitor v) { v.visitArray(this); }
+        @Override
         public String toString() {
             StringBuilder buf = new StringBuilder();
             buf.append('{');
@@ -241,9 +258,11 @@ public abstract class Attribute implements AnnotationValue {
             buf.append('}');
             return buf.toString();
         }
+        @Override
         public List<Attribute> getValue() {
             return List.from(values);
         }
+        @Override
         public <R, P> R accept(AnnotationValueVisitor<R, P> v, P p) {
             return v.visitArray(getValue(), p);
         }
@@ -258,29 +277,61 @@ public abstract class Attribute implements AnnotationValue {
             assert value != null;
             this.value = value;
         }
+        @Override
         public void accept(Visitor v) { v.visitEnum(this); }
+        @Override
         public String toString() {
             return value.enclClass() + "." + value;     // qualified name
         }
+        @Override
         public VarSymbol getValue() {
             return value;
         }
+        @Override
         public <R, P> R accept(AnnotationValueVisitor<R, P> v, P p) {
             return v.visitEnumConstant(value, p);
         }
     }
+    
+    public static class Expression extends Attribute {
+      private JCExpression expr;
+
+      public Expression(Type type, JCExpression expr) {
+        super(type);
+        this.expr = expr;
+      }
+
+      @Override
+      public void accept(Visitor v) {
+        v.visitExpression(this);
+      }
+
+      @Override
+      public JCExpression getValue() {
+        return expr;
+      }
+      
+      @Override
+      public String toString() {
+        return expr.toString();
+      }
+    }
 
     public static class Error extends Attribute {
         public Error(Type type) {
             super(type);
         }
+        @Override
         public void accept(Visitor v) { v.visitError(this); }
+        @Override
         public String toString() {
             return "<error>";
         }
+        @Override
         public String getValue() {
             return toString();
         }
+        @Override
         public <R, P> R accept(AnnotationValueVisitor<R, P> v, P p) {
             return v.visitString(toString(), p);
         }
@@ -293,6 +344,7 @@ public abstract class Attribute implements AnnotationValue {
         void visitCompound(Attribute.Compound compound);
         void visitArray(Attribute.Array array);
         void visitEnum(Attribute.Enum e);
+        void visitExpression(Attribute.Expression e);
         void visitError(Attribute.Error e);
     }
 }
diff --git a/langtools/src/share/classes/com/sun/tools/javac/code/Lint.java b/langtools/src/share/classes/com/sun/tools/javac/code/Lint.java
index cec6e70..ecacfe2 100644
--- a/langtools/src/share/classes/com/sun/tools/javac/code/Lint.java
+++ b/langtools/src/share/classes/com/sun/tools/javac/code/Lint.java
@@ -119,6 +119,7 @@ public class Lint
         this.suppressedValues = other.suppressedValues.clone();
     }
 
+    @Override
     public String toString() {
         return "Lint:[values" + values + " suppressedValues" + suppressedValues + "]";
     }
@@ -312,6 +313,9 @@ public class Lint
 
         public void visitEnum(Attribute.Enum e) {
         }
+        
+        public void visitExpression(Attribute.Expression e) {
+        }
 
         public void visitError(Attribute.Error e) {
         }
diff --git a/langtools/src/share/classes/com/sun/tools/javac/code/Symtab.java b/langtools/src/share/classes/com/sun/tools/javac/code/Symtab.java
index 8d708bc..c197936 100644
--- a/langtools/src/share/classes/com/sun/tools/javac/code/Symtab.java
+++ b/langtools/src/share/classes/com/sun/tools/javac/code/Symtab.java
@@ -132,6 +132,7 @@ public class Symtab {
     public final Type assertionErrorType;
     public final Type cloneNotSupportedExceptionType;
     public final Type annotationType;
+    public final Type annotationAllowNonConstant;
     public final TypeSymbol enumSym;
     public final Type listType;
     public final Type collectionsType;
@@ -358,7 +359,8 @@ public class Symtab {
         rootPackage = new PackageSymbol(names.empty, null);
         final JavacMessages messages = JavacMessages.instance(context);
         unnamedPackage = new PackageSymbol(names.empty, rootPackage) {
-                public String toString() {
+                @Override
+		public String toString() {
                     return messages.getLocalizedString("compiler.misc.unnamed.package");
                 }
             };
@@ -454,6 +456,7 @@ public class Symtab {
             : enterClass("java.util.Collection");
         iteratorType = enterClass("java.util.Iterator");
         annotationTargetType = enterClass("java.lang.annotation.Target");
+        annotationAllowNonConstant = enterClass("java.lang.annotation.AllowNonConstant");
         overrideType = enterClass("java.lang.Override");
         retentionType = enterClass("java.lang.annotation.Retention");
         deprecatedType = enterClass("java.lang.Deprecated");
diff --git a/langtools/src/share/classes/com/sun/tools/javac/comp/Annotate.java b/langtools/src/share/classes/com/sun/tools/javac/comp/Annotate.java
index 0d882f7..82a67bf 100644
--- a/langtools/src/share/classes/com/sun/tools/javac/comp/Annotate.java
+++ b/langtools/src/share/classes/com/sun/tools/javac/comp/Annotate.java
@@ -187,15 +187,14 @@ public class Annotate {
     }
 
     Attribute enterAttributeValue(Type expected,
-                                  JCExpression tree,
+	                          JCExpression tree,
                                   Env<AttrContext> env) {
         if (expected.isPrimitive() || types.isSameType(expected, syms.stringType)) {
             Type result = attr.attribExpr(tree, env, expected);
             if (result.isErroneous())
                 return new Attribute.Error(expected);
             if (result.constValue() == null) {
-                log.error(tree.pos(), "attribute.value.must.be.constant");
-                return new Attribute.Error(expected);
+        	return new Attribute.Expression(expected, tree);
             }
             result = cfolder.coerce(result, expected);
             return new Attribute.Constant(expected, result.constValue());
@@ -205,8 +204,7 @@ public class Annotate {
             if (result.isErroneous())
                 return new Attribute.Error(expected);
             if (TreeInfo.name(tree) != names._class) {
-                log.error(tree.pos(), "annotation.value.must.be.class.literal");
-                return new Attribute.Error(expected);
+        	return new Attribute.Expression(expected, tree);
             }
             return new Attribute.Class(types,
                                        (((JCFieldAccess) tree).selected).type);
@@ -219,6 +217,7 @@ public class Annotate {
             return enterAnnotation((JCAnnotation)tree, expected, env);
         }
         if (expected.tag == TypeTags.ARRAY) { // should really be isArray()
+            // Array arguments are required to be constants
             if (tree.getTag() != JCTree.NEWARRAY) {
                 tree = make.at(tree.pos).
                     NewArray(null, List.<JCExpression>nil(), List.of(tree));
@@ -230,29 +229,39 @@ public class Annotate {
             }
             ListBuffer<Attribute> buf = new ListBuffer<Attribute>();
             for (List<JCExpression> l = na.elems; l.nonEmpty(); l=l.tail) {
-                buf.append(enterAttributeValue(types.elemtype(expected),
-                                               l.head,
-                                               env));
-            }
-            return new Attribute.
-                Array(expected, buf.toArray(new Attribute[buf.length()]));
-        }
+                Attribute attrib = enterAttributeValue(types.elemtype(expected),
+                	                       l.head,
+                                               env);
+                if (attrib instanceof Attribute.Expression) {
+                    log.error(l.head, "attribute.value.must.be.constant");
+		    return new Attribute.Error(types.elemtype(expected));
+		}
+		buf.append(attrib);
+	    }
+	    return new Attribute.Array(expected, buf.toArray(new Attribute[buf
+		    .length()]));
+	}
         if (expected.tag == TypeTags.CLASS &&
             (expected.tsym.flags() & Flags.ENUM) != 0) {
-            attr.attribExpr(tree, env, expected);
+            Type result = attr.attribExpr(tree, env, expected);
+            if (result.isErroneous()) {
+        	return new Attribute.Error(expected);
+            }
             Symbol sym = TreeInfo.symbol(tree);
             if (sym == null ||
                 TreeInfo.nonstaticSelect(tree) ||
                 sym.kind != Kinds.VAR ||
                 (sym.flags() & Flags.ENUM) == 0) {
-                log.error(tree.pos(), "enum.annotation.must.be.enum.constant");
-                return new Attribute.Error(expected);
+        	return new Attribute.Expression(expected, tree);
             }
             VarSymbol enumerator = (VarSymbol) sym;
             return new Attribute.Enum(expected, enumerator);
         }
-        if (!expected.isErroneous())
-            log.error(tree.pos(), "annotation.value.not.allowable.type");
-        return new Attribute.Error(attr.attribExpr(tree, env, expected));
+
+        Type result = attr.attribExpr(tree, env, expected);
+        if (result.isErroneous()) {
+            return new Attribute.Error(expected);
+        }
+        return new Attribute.Expression(expected, tree);
     }
 }
diff --git a/langtools/src/share/classes/com/sun/tools/javac/comp/Attr.java b/langtools/src/share/classes/com/sun/tools/javac/comp/Attr.java
index f344c72..92c1efa 100644
--- a/langtools/src/share/classes/com/sun/tools/javac/comp/Attr.java
+++ b/langtools/src/share/classes/com/sun/tools/javac/comp/Attr.java
@@ -26,7 +26,6 @@
 package com.sun.tools.javac.comp;
 
 import java.util.*;
-import java.util.Set;
 import javax.lang.model.element.ElementKind;
 import javax.tools.JavaFileObject;
 
@@ -591,6 +590,7 @@ public class Attr extends JCTree.Visitor {
         return t;
     }
 
+    @Override
     public void visitClassDef(JCClassDecl tree) {
         // Local classes have not been entered yet, so we need to do it now:
         if ((env.info.scope.owner.kind & (VAR | MTH)) != 0)
@@ -620,6 +620,7 @@ public class Attr extends JCTree.Visitor {
         }
     }
 
+    @Override
     public void visitMethodDef(JCMethodDecl tree) {
         MethodSymbol m = tree.sym;
 
@@ -664,8 +665,9 @@ public class Attr extends JCTree.Visitor {
 
             // Check that result type is well-formed.
             chk.validate(tree.restype, localEnv);
-            if ((owner.flags() & ANNOTATION) != 0)
-                chk.validateAnnotationType(tree.restype);
+            if ((owner.flags() & ANNOTATION) != 0
+		    && tree.sym.attribute(syms.annotationAllowNonConstant.tsym) == null)
+                chk.validateAnnotationTypeAsConstant(tree.restype);
 
             if ((owner.flags() & ANNOTATION) != 0)
                 chk.validateAnnotationMethod(tree.pos(), m);
@@ -728,13 +730,14 @@ public class Attr extends JCTree.Visitor {
             }
             localEnv.info.scope.leave();
             result = tree.type = m.type;
-            chk.validateAnnotations(tree.mods.annotations, m);
+            chk.validateAnnotations(tree.mods.annotations, m, env);
         }
         finally {
             chk.setLint(prevLint);
         }
     }
 
+    @Override
     public void visitVarDef(JCVariableDecl tree) {
         // Local variables have not been entered yet, so we need to do it now:
         if (env.info.scope.owner.kind == MTH) {
@@ -776,17 +779,19 @@ public class Attr extends JCTree.Visitor {
                 }
             }
             result = tree.type = v.type;
-            chk.validateAnnotations(tree.mods.annotations, v);
+            chk.validateAnnotations(tree.mods.annotations, v, env);
         }
         finally {
             chk.setLint(prevLint);
         }
     }
 
+    @Override
     public void visitSkip(JCSkip tree) {
         result = null;
     }
 
+    @Override
     public void visitBlock(JCBlock tree) {
         if (env.info.scope.owner.kind == TYP) {
             // Block is a static or instance initializer;
@@ -809,18 +814,21 @@ public class Attr extends JCTree.Visitor {
         result = null;
     }
 
+    @Override
     public void visitDoLoop(JCDoWhileLoop tree) {
         attribStat(tree.body, env.dup(tree));
         attribExpr(tree.cond, env, syms.booleanType);
         result = null;
     }
 
+    @Override
     public void visitWhileLoop(JCWhileLoop tree) {
         attribExpr(tree.cond, env, syms.booleanType);
         attribStat(tree.body, env.dup(tree));
         result = null;
     }
 
+    @Override
     public void visitForLoop(JCForLoop tree) {
         Env<AttrContext> loopEnv =
             env.dup(env.tree, env.info.dup(env.info.scope.dup()));
@@ -833,6 +841,7 @@ public class Attr extends JCTree.Visitor {
         result = null;
     }
 
+    @Override
     public void visitForeachLoop(JCEnhancedForLoop tree) {
         Env<AttrContext> loopEnv =
             env.dup(env.tree, env.info.dup(env.info.scope.dup()));
@@ -860,6 +869,7 @@ public class Attr extends JCTree.Visitor {
         result = null;
     }
 
+    @Override
     public void visitLabelled(JCLabeledStatement tree) {
         // Check that label is not used in an enclosing statement
         Env<AttrContext> env1 = env;
@@ -877,6 +887,7 @@ public class Attr extends JCTree.Visitor {
         result = null;
     }
 
+    @Override
     public void visitSwitch(JCSwitch tree) {
         Type seltype = attribExpr(tree.selector, env);
 
@@ -961,12 +972,14 @@ public class Attr extends JCTree.Visitor {
         return null;
     }
 
+    @Override
     public void visitSynchronized(JCSynchronized tree) {
         chk.checkRefType(tree.pos(), attribExpr(tree.lock, env));
         attribStat(tree.body, env);
         result = null;
     }
 
+    @Override
     public void visitTry(JCTry tree) {
         // Attribute body
         attribStat(tree.body, env.dup(tree, env.info.dup()));
@@ -992,6 +1005,7 @@ public class Attr extends JCTree.Visitor {
         result = null;
     }
 
+    @Override
     public void visitConditional(JCConditional tree) {
         attribExpr(tree.cond, env, syms.booleanType);
         attribExpr(tree.truepart, env);
@@ -1095,6 +1109,7 @@ public class Attr extends JCTree.Visitor {
             return types.lub(thentype.baseType(), elsetype.baseType());
         }
 
+    @Override
     public void visitIf(JCIf tree) {
         attribExpr(tree.cond, env, syms.booleanType);
         attribStat(tree.thenpart, env);
@@ -1104,16 +1119,19 @@ public class Attr extends JCTree.Visitor {
         result = null;
     }
 
+    @Override
     public void visitExec(JCExpressionStatement tree) {
         attribExpr(tree.expr, env);
         result = null;
     }
 
+    @Override
     public void visitBreak(JCBreak tree) {
         tree.target = findJumpTarget(tree.pos(), tree.getTag(), tree.label, env);
         result = null;
     }
 
+    @Override
     public void visitContinue(JCContinue tree) {
         tree.target = findJumpTarget(tree.pos(), tree.getTag(), tree.label, env);
         result = null;
@@ -1184,6 +1202,7 @@ public class Attr extends JCTree.Visitor {
             return null;
         }
 
+    @Override
     public void visitReturn(JCReturn tree) {
         // Check that there is an enclosing method which is
         // nested within than the enclosing class.
@@ -1208,11 +1227,13 @@ public class Attr extends JCTree.Visitor {
         result = null;
     }
 
+    @Override
     public void visitThrow(JCThrow tree) {
         attribExpr(tree.expr, env, syms.throwableType);
         result = null;
     }
 
+    @Override
     public void visitAssert(JCAssert tree) {
         attribExpr(tree.cond, env, syms.booleanType);
         if (tree.detail != null) {
@@ -1225,6 +1246,7 @@ public class Attr extends JCTree.Visitor {
      *  NOTE: The method part of an application will have in its type field
      *        the return type of the method, not the method's type itself!
      */
+    @Override
     public void visitApply(JCMethodInvocation tree) {
         // The local environment of a method application is
         // a new environment nested in the current one.
@@ -1409,6 +1431,7 @@ public class Attr extends JCTree.Visitor {
             return (typeargtypes == null) ? mt : (Type)new ForAll(typeargtypes, mt);
         }
 
+    @Override
     public void visitNewClass(JCNewClass tree) {
         Type owntype = types.createErrorType(tree.type);
 
@@ -1623,6 +1646,7 @@ public class Attr extends JCTree.Visitor {
         return tree;
     }
 
+    @Override
     public void visitNewArray(JCNewArray tree) {
         Type owntype = types.createErrorType(tree.type);
         Type elemtype;
@@ -1656,6 +1680,7 @@ public class Attr extends JCTree.Visitor {
         result = check(tree, owntype, VAL, pkind, pt);
     }
 
+    @Override
     public void visitParens(JCParens tree) {
         Type owntype = attribTree(tree.expr, env, pkind, pt);
         result = check(tree, owntype, pkind, pkind, pt);
@@ -1664,6 +1689,7 @@ public class Attr extends JCTree.Visitor {
             log.error(tree.pos(), "illegal.start.of.type");
     }
 
+    @Override
     public void visitAssign(JCAssign tree) {
         Type owntype = attribTree(tree.lhs, env.dup(tree), VAR, Type.noType);
         Type capturedType = capture(owntype);
@@ -1671,6 +1697,7 @@ public class Attr extends JCTree.Visitor {
         result = check(tree, capturedType, VAL, pkind, pt);
     }
 
+    @Override
     public void visitAssignop(JCAssignOp tree) {
         // Attribute arguments.
         Type owntype = attribTree(tree.lhs, env, VAR, Type.noType);
@@ -1694,6 +1721,7 @@ public class Attr extends JCTree.Visitor {
         result = check(tree, owntype, VAL, pkind, pt);
     }
 
+    @Override
     public void visitUnary(JCUnary tree) {
         // Attribute arguments.
         Type argtype = (JCTree.PREINC <= tree.getTag() && tree.getTag() <= JCTree.POSTDEC)
@@ -1731,6 +1759,7 @@ public class Attr extends JCTree.Visitor {
         result = check(tree, owntype, VAL, pkind, pt);
     }
 
+    @Override
     public void visitBinary(JCBinary tree) {
         // Attribute arguments.
         Type left = chk.checkNonVoid(tree.lhs.pos(), attribExpr(tree.lhs, env));
@@ -1782,6 +1811,7 @@ public class Attr extends JCTree.Visitor {
         result = check(tree, owntype, VAL, pkind, pt);
     }
 
+    @Override
     public void visitTypeCast(JCTypeCast tree) {
         Type clazztype = attribType(tree.clazz, env);
         chk.validate(tree.clazz, env);
@@ -1792,6 +1822,7 @@ public class Attr extends JCTree.Visitor {
         result = check(tree, capture(owntype), VAL, pkind, pt);
     }
 
+    @Override
     public void visitTypeTest(JCInstanceOf tree) {
         Type exprtype = chk.checkNullOrRefType(
             tree.expr.pos(), attribExpr(tree.expr, env));
@@ -1802,6 +1833,7 @@ public class Attr extends JCTree.Visitor {
         result = check(tree, syms.booleanType, VAL, pkind, pt);
     }
 
+    @Override
     public void visitIndexed(JCArrayAccess tree) {
         Type owntype = types.createErrorType(tree.type);
         Type atype = attribExpr(tree.indexed, env);
@@ -1814,6 +1846,7 @@ public class Attr extends JCTree.Visitor {
         result = check(tree, owntype, VAR, pkind, pt);
     }
 
+    @Override
     public void visitIdent(JCIdent tree) {
         Symbol sym;
         boolean varArgs = false;
@@ -1899,6 +1932,7 @@ public class Attr extends JCTree.Visitor {
         result = checkId(tree, env1.enclClass.sym.type, sym, env, pkind, pt, varArgs);
     }
 
+    @Override
     public void visitSelect(JCFieldAccess tree) {
         // Determine the expected kind of the qualifier expression.
         int skind = 0;
@@ -2509,6 +2543,7 @@ public class Attr extends JCTree.Visitor {
         }
     }
 
+    @Override
     public void visitLiteral(JCLiteral tree) {
         result = check(
             tree, litType(tree.typetag).constType(tree.value), VAL, pkind, pt);
@@ -2520,10 +2555,12 @@ public class Attr extends JCTree.Visitor {
         return (tag == TypeTags.CLASS) ? syms.stringType : syms.typeOfTag[tag];
     }
 
+    @Override
     public void visitTypeIdent(JCPrimitiveTypeTree tree) {
         result = check(tree, syms.typeOfTag[tree.typetag], TYP, pkind, pt);
     }
 
+    @Override
     public void visitTypeArray(JCArrayTypeTree tree) {
         Type etype = attribType(tree.elemtype, env);
         Type type = new ArrayType(etype, syms.arrayClass);
@@ -2534,6 +2571,7 @@ public class Attr extends JCTree.Visitor {
      *  Bound checking is left until later, since types are attributed
      *  before supertype structure is completely known
      */
+    @Override
     public void visitTypeApply(JCTypeApply tree) {
         Type owntype = types.createErrorType(tree.type);
 
@@ -2597,6 +2635,7 @@ public class Attr extends JCTree.Visitor {
         result = check(tree, owntype, TYP, pkind, pt);
     }
 
+    @Override
     public void visitTypeParameter(JCTypeParameter tree) {
         TypeVar a = (TypeVar)tree.type;
         Set<Type> boundSet = new HashSet<Type>();
@@ -2666,6 +2705,7 @@ public class Attr extends JCTree.Visitor {
     }
 
 
+    @Override
     public void visitWildcard(JCWildcard tree) {
         //- System.err.println("visitWildcard("+tree+");");//DEBUG
         Type type = (tree.kind.kind == BoundKind.UNBOUND)
@@ -2677,15 +2717,25 @@ public class Attr extends JCTree.Visitor {
                        TYP, pkind, pt);
     }
 
+    @Override
     public void visitAnnotation(JCAnnotation tree) {
         log.error(tree.pos(), "annotation.not.valid.for.type", pt);
         result = tree.type = syms.errType;
     }
 
+    @Override
     public void visitAnnotatedType(JCAnnotatedType tree) {
         result = tree.type = attribType(tree.getUnderlyingType(), env);
+        // Also check any trees within the annotations
+        // TODO(spoon): this should apply to annotations on other things than types
+        for (JCTypeAnnotation annot : tree.getAnnotations()) {
+          for (JCExpression arg : annot.getArguments()) {
+            attribExpr(arg, env);
+          }
+        }
     }
 
+    @Override
     public void visitErroneous(JCErroneous tree) {
         if (tree.errs != null)
             for (JCTree err : tree.errs)
@@ -2695,6 +2745,7 @@ public class Attr extends JCTree.Visitor {
 
     /** Default visitor method for all other trees.
      */
+    @Override
     public void visitTree(JCTree tree) {
         throw new AssertionError();
     }
@@ -2783,6 +2834,7 @@ public class Attr extends JCTree.Visitor {
         }
     }
 
+    @Override
     public void visitImport(JCImport tree) {
         // nothing to do
     }
@@ -2793,7 +2845,7 @@ public class Attr extends JCTree.Visitor {
         assert c == tree.sym;
 
         // Validate annotations
-        chk.validateAnnotations(tree.mods.annotations, c);
+        chk.validateAnnotations(tree.mods.annotations, c, env);
 
         // Validate type parameters, supertype and interfaces.
         attribBounds(tree.typarams);
@@ -2926,17 +2978,20 @@ public class Attr extends JCTree.Visitor {
     //where
     private final JCTree.Visitor typeAnnotationsValidator =
         new TreeScanner() {
+        @Override
         public void visitAnnotation(JCAnnotation tree) {
             if (tree instanceof JCTypeAnnotation) {
                 chk.validateTypeAnnotation((JCTypeAnnotation)tree, false);
             }
             super.visitAnnotation(tree);
         }
+        @Override
         public void visitTypeParameter(JCTypeParameter tree) {
-            chk.validateTypeAnnotations(tree.annotations, true);
+            chk.validateTypeAnnotations(tree.annotations, true, env);
             // don't call super. skip type annotations
             scan(tree.bounds);
         }
+        @Override
         public void visitMethodDef(JCMethodDecl tree) {
             // need to check static methods
             if ((tree.sym.flags() & Flags.STATIC) != 0) {
